export default {
  namespace: 'main',
  state: {
    nowFlag: "X",
    list: [{
      value: 1,
      flag: null,
    }, {
      value: 2,
      flag: null,
    }, {
      value: 3,
      flag: null,
    }, {
      value: 4,
      flag: null,
    }, {
      value: 5,
      flag: null,
    }, {
      value: 6,
      flag: null,
    }, {
      value: 7,
      flag: null,
    }, {
      value: 8,
      flag: null,
    }, {
      value: 9,
      flag: null,
    }],
    actionData: [],
    winner: null,
    goBackKey: null
  },
  reducers: {
    updateflag(state, action) {
      const { tempFlag } = action.payload
      return {
        ...state,
        nowFlag: tempFlag,
      }
    },
    updateSelectOne(state, action) {
      const { tempArry } = action.payload
      return {
        ...state,
        list: tempArry
      }
    },
    updateAction(state, action) {
      const { actionData } = action.payload
      return {
        ...state,
        actionData: actionData,
        goBackKey: null
      }
    },
    updateRenderData(state, action) {
      const { tempData, tempActionData, tempNowFlag, goBackKey } = action.payload
      return {
        ...state,
        list: tempData,
        actionData: tempActionData,
        nowFlag: tempNowFlag,
        goBackKey: goBackKey
      }
    },
    updateWinner(state, action) {
      const { winner } = action.payload
      return {
        ...state,
        winner: winner,
        goBackKey: null
      }
    }
  },
  effects: {
    // 更新对象
    * updateObjFn({
      id,
      flag,
    }, {
      call,
      put,
      select
    }) {
      // 更新当前点击的对象的标记
      const tempList = yield select(state=> state.main.list)
      let tempArry = JSON.parse(JSON.stringify(tempList))
      let index = tempArry.findIndex((item, index) => {
        return item.value === id
      })
      tempArry[index].flag = flag
      let tempFlag = flag === "X" ? "O" : "X"
      yield put({
        type: "updateSelectOne",
        payload:{ tempArry }
      })
      // 更新全局的标记
      yield put({
        type: 'updateflag',
        payload:{ tempFlag }
      })
    },
    // 保存每一步的操作
    * saveActionFn({
      id,
      flag,
    }, {
      call,
      put,
      select
    }) {
      const tempList = yield select(state=> state.main.list)
      let actionData = yield select(state=> state.main.actionData)
      const goBackKey = yield select(state=> state.main.goBackKey)
      let tempArry = JSON.parse(JSON.stringify(tempList)) // 深拷贝
      let index = tempArry.findIndex((item, index) => {
        return item.value === id
      })
      tempArry[index].flag = flag
      if(goBackKey) {
        actionData = actionData.slice(0, goBackKey)
      }
      actionData.push({
        key: actionData.length+1,
        value: tempArry,
        flag: flag
      })
      // console.log("actionData",actionData)
      yield put({
        type: 'updateAction',
        payload:{ actionData }
      })
    },
    // 回退操作
    * updateRenderDataFn({
      booleanFlag,
      key,
      actionData,
    }, {
      call,
      put,
      select
    }) {
      const tempList = yield select(state=> state.main.list)
      let tempNowFlag = yield select(state=> state.main.nowFlag)
      let tempActionDataList = JSON.parse(JSON.stringify(actionData))
      let tempData = []
      let tempActionData = []
      let goBackKey = null
      // 如果点击的不是重玩
      if (!booleanFlag) {
        let index = tempActionDataList.findIndex((item, index) => {
          return item.key === key
        })
        tempData = tempActionDataList.find((item, index) => {
          return item.key === key
        }).value
        //  tempActionData = tempActionDataList.slice(0, index + 1)
        tempActionData = tempActionDataList
        tempNowFlag = tempActionDataList[index].flag === 'X' ? 'O' : 'X'
        goBackKey = key
      } else {
        tempData = tempList.map((item, index) => {
          let temp = {}
          temp.value = item.value
          temp.flag = null
          return temp
        })
        tempNowFlag = 'X'
      }
      yield put({
        type: 'updateRenderData',
        payload:{ tempData, tempActionData,tempNowFlag, goBackKey }
      })
    },
    // 更新获胜者
    * updateWinnerFn({
      winner
    }, {
      call,
      put,
      select
    }) {
      yield put({
        type: "updateWinner",
        payload:{ winner }
      })
    }
  },
  subscriptions: {

  },
};
